﻿using UnityEngine;

public class Player : MonoBehaviour {
    public float speed;
    private Vector2 moveVelocity;
    public Vector2 lookVector = new Vector2(0,0);
    public Rigidbody2D rigidbody;
    public Collider2D furniture;
    public GameObject player;
    public DistanceJoint2D joint;
    public bool grabbing = false;
    public GameObject hand;
    private GameObject hand1;
    private GameObject hand2;
    private float handx1;
    private float handx2;
    private float handy1;
    private float handy2;

    public Sprite playerstill;
    public Sprite playermove1;
    public Sprite playermove2;
    public AudioClip grabSound;

    private int step;
    private AudioSource audio;

	// Use this for initialization
	void Start () {
        rigidbody = GetComponent<Rigidbody2D>();
        step = 0;
        audio = GetComponent<AudioSource>();

	}
	
	// Update is called once per frame
	void Update () {
        updateRotate();
        Vector2 moveInput = new Vector2(Input.GetAxisRaw("Horizontal"), Input.GetAxisRaw("Vertical"));
        moveVelocity = moveInput.normalized * speed;	
        rigidbody.MovePosition(rigidbody.position + moveVelocity * Time.fixedDeltaTime);

        if(moveVelocity.x != 0 || moveVelocity.y !=0)
        {
            if(this.GetComponent<SpriteRenderer>().sprite != playermove1 && step == 0)
            {
                this.GetComponent<SpriteRenderer>().sprite = playermove1;
                step = 3;
            }
            else if(this.GetComponent<SpriteRenderer>().sprite != playermove2 && step == 0)
            {
                this.GetComponent<SpriteRenderer>().sprite = playermove2;
                step = 3;
            }
            else
            {
                step--;
            }
            if(!grabbing)
            {
                lookVector = moveVelocity.normalized;
            }
        }
        else
        {
            this.GetComponent<SpriteRenderer>().sprite = playerstill;
        }
        if(furniture != null)
        {
            lookVector = new Vector2(furniture.transform.position.x-player.transform.position.x,furniture.transform.position.y-player.transform.position.y);
        }

        if(Input.GetAxisRaw("Jump") == 1)
        {
            if(hand1 == null && hand2 == null)
            {   
                hand1 = Object.Instantiate(hand, new Vector2(this.transform.position.x+handx1,this.transform.position.y+handy1), this.transform.rotation);
                hand2 = Object.Instantiate(hand, new Vector2(this.transform.position.x+handx2,this.transform.position.y+handy2), this.transform.rotation);
                hand1.transform.parent = player.transform;
                hand2.transform.parent = player.transform;
                audio.PlayOneShot(grabSound, 0.7f);
            }
            
            grabbing = true;
            if(joint == null)
            {
                
                //Debug.Log(new Vector2(player.transform.position.x + lookVector.x*1.75f,
                    //player.transform.position.y + lookVector.y*1.75f));
                Collider2D hitColliders = Physics2D.OverlapCircle(new Vector2(player.transform.position.x + lookVector.x,
                    player.transform.position.y + lookVector.y), 0.25f);
                if(hitColliders != null)
                {
                    //Debug.Log("Ray hit");
                    furniture = hitColliders;
                    joint = player.AddComponent(typeof(DistanceJoint2D)) as DistanceJoint2D;
                    joint.connectedBody = furniture.GetComponent<Rigidbody2D>();
                }
                //Debug.Log("Ray miss");

            }
        }
        else if(joint != null)
        {
            Destroy(joint);
            grabbing = false;
            furniture = null;
            Destroy(hand1);
            Destroy(hand2);
        }
        else
        {
            furniture = null;
            grabbing = false;
            Destroy(hand1);
            Destroy(hand2);
        }
	}

    void updateRotate()
    {   //Up
        if(lookVector.x > -0.5f && lookVector.x < 0.5f && lookVector.y > 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,180));
            handx1 = 0.6f;
            handx2 = -0.6f;
            handy1 = 0.3f;
            handy2 = 0.3f;
        }

        //Down
        else if(lookVector.x > -0.5f && lookVector.x < 0.5f && lookVector.y < 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,0));
            handx1 = 0.6f;
            handx2 = -0.6f;
            handy1 = -0.3f;
            handy2 = -0.3f;
        }

        //Left
        else if(lookVector.y > -0.5f && lookVector.y < 0.5f && lookVector.x < 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,270));
            handx1 = -0.3f;
            handx2 = -0.3f;
            handy1 = 0.6f;
            handy2 = -0.6f;
        }

        //Right
        else if(lookVector.y > -0.5f && lookVector.y < 0.5f && lookVector.x > 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,90));
            handx1 = 0.3f;
            handx2 = 0.3f;
            handy1 = -0.6f;
            handy2 = 0.6f;
        }

        //TopRight
        else if(lookVector.y > 0 && lookVector.x > 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,135));
            handx1 = 0f;
            handx2 = 0.6f;
            handy1 = 0.6f;
            handy2 = 0f;
        }

        //BottomRight
        else if(lookVector.y < 0 && lookVector.x > 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,45));
            handx1 = 0.6f;
            handx2 = 0f;
            handy1 = 0f;
            handy2 = -0.6f;
        }

        //TopLeft
        else if(lookVector.y > 0 && lookVector.x < 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,225));
            handx1 = 0f;
            handx2 = -0.6f;
            handy1 = 0.6f;
            handy2 = 0f;
        }

        //BottomLeft
        else if(lookVector.y < 0 && lookVector.x < 0)
        {
            player.transform.rotation = Quaternion.Euler(new Vector3(0,0,315));
            handx1 = 0f;
            handx2 = -0.6f;
            handy1 = -0.6f;
            handy2 = 0f;
        }
    }
}
